commit 1c366ac98de168d4d2a25de16d9560ced4933381
Author: Stavros Sachtouris <saxtouri@admin.grnet.gr>
Date:   Fri Dec 6 16:36:12 2013 +0200

    Complete updating documentation
    
    Refs: #4692

diff --git a/docs/developers/code.rst b/docs/developers/code.rst
index 3023302..cfd8e80 100644
--- a/docs/developers/code.rst
+++ b/docs/developers/code.rst
@@ -6,22 +6,27 @@ APIs code
 Command Specifications
 ----------------------
 
-user
-^^^^
+astakos
+^^^^^^^
+Features: user, project, quota, resource, commission, endpoint, service
 
 .. automodule:: kamaki.cli.commands.astakos
     :members:
     :undoc-members:
 
-cyclades (server, flavor, network)
-^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+cyclades
+^^^^^^^^
+
+Features server, flavor
 
 .. automodule:: kamaki.cli.commands.cyclades
     :members:
     :undoc-members:
 
-pithos (file)
-^^^^^^^^^^^^^
+pithos
+^^^^^^
+
+Features file, container, sharer, group
 
 .. automodule:: kamaki.cli.commands.pithos
     :members:
@@ -30,129 +35,68 @@ pithos (file)
 image
 ^^^^^
 
-.. automodule:: kamaki.cli.commands.image
-    :members:
-    :undoc-members:
-
-Kamaki commands
-^^^^^^^^^^^^^^^
-
-config
-""""""
-
-.. automodule:: kamaki.cli.commands.config
-    :members:
-    :undoc-members:
-
-history
-"""""""
+Features (image, imagecompute)
 
-.. automodule:: kamaki.cli.commands.history
-    :members:
-    :undoc-members:
-
-Command Line Interfaces
------------------------
-
-argument
-^^^^^^^^
-
-.. automodule:: kamaki.cli.argument
+.. automodule:: kamaki.cli.commands.image
     :members:
-    :show-inheritance:
     :undoc-members:
 
 
-command_shell
-^^^^^^^^^^^^^
-
-.. automodule:: kamaki.cli.command_shell
-    :members:
-    :show-inheritance:
-    :undoc-members:
-
+network
+^^^^^^^
 
-command_tree
-^^^^^^^^^^^^
+Features network, port, subnet, ip
 
-.. automodule:: kamaki.cli.command_tree
+.. automodule:: kamaki.cli.commands.network
     :members:
-    :show-inheritance:
     :undoc-members:
 
+Kamaki commands
+^^^^^^^^^^^^^^^
 
 config
-^^^^^^
+""""""
 
-.. automodule:: kamaki.cli.config
+.. automodule:: kamaki.cli.commands.config
     :members:
-    :show-inheritance:
     :undoc-members:
 
+
 errors
 ^^^^^^
 
-.. automodule:: kamaki.cli.errors
-    :members:
-    :show-inheritance:
-    :undoc-members:
-
-
-history
-^^^^^^^
-
-.. automodule:: kamaki.cli.history
-    :members:
-    :show-inheritance:
-    :undoc-members:
-
-
-utils
-^^^^^
-
-.. automodule:: kamaki.cli.utils
+.. automodule:: kamaki.cli.commands.errors
     :members:
     :show-inheritance:
     :undoc-members:
 
-
 .. _the-client-api-ref:
 
 The clients API
 ---------------
 
-Modules list
-^^^^^^^^^^^^
-
-compute REST API
-^^^^^^^^^^^^^^^^
+compute
+^^^^^^^
 
 .. automodule:: kamaki.clients.compute.rest_api
     :members:
     :show-inheritance:
     :undoc-members:
 
-
-compute
-^^^^^^^
-
 .. automodule:: kamaki.clients.compute
     :members:
     :show-inheritance:
     :undoc-members:
 
 
-cyclades REST API
-^^^^^^^^^^^^^^^^^
+cyclades
+^^^^^^^^
 
 .. automodule:: kamaki.clients.cyclades.rest_api
     :members:
     :show-inheritance:
     :undoc-members:
 
-cyclades
-^^^^^^^^
-
 .. automodule:: kamaki.clients.cyclades
     :members:
     :show-inheritance:
@@ -167,17 +111,14 @@ storage
     :show-inheritance:
     :undoc-members:
 
-pithos_rest_api
-^^^^^^^^^^^^^^^
+pithos
+^^^^^^
 
 .. automodule:: kamaki.clients.pithos.rest_api
     :members:
     :show-inheritance:
     :undoc-members:
 
-pithos
-^^^^^^
-
 .. automodule:: kamaki.clients.pithos
     :members:
     :show-inheritance:
@@ -191,20 +132,21 @@ image
     :show-inheritance:
     :undoc-members:
 
-
-astakos
+network
 ^^^^^^^
 
-.. automodule:: kamaki.clients.astakos
+.. warning:: For synnefo, the suggested network implementation is in
+    kamaki.clients.cyclades.CycladesNetworkClient extension
+
+.. automodule:: kamaki.clients.network
     :members:
     :show-inheritance:
     :undoc-members:
 
+astakos
+^^^^^^^
 
-utils
-^^^^^
-
-.. automodule:: kamaki.clients.utils
+.. automodule:: kamaki.clients.astakos
     :members:
     :show-inheritance:
     :undoc-members: