commit 1c366ac98de168d4d2a25de16d9560ced4933381
Author: Stavros Sachtouris <saxtouri@admin.grnet.gr>
Date:   Fri Dec 6 16:36:12 2013 +0200

    Complete updating documentation
    
    Refs: #4692

diff --git a/kamaki/clients/compute/__init__.py b/kamaki/clients/compute/__init__.py
index 9cff47a..a8a83fc 100644
--- a/kamaki/clients/compute/__init__.py
+++ b/kamaki/clients/compute/__init__.py
@@ -130,9 +130,9 @@ class ComputeClient(ComputeRestClient):
 
         :param networks: (list of dicts) Networks to connect to, list this:
             "networks": [
-                {"network": <network_uuid>},
-                {"network": <network_uuid>, "fixed_ip": address},
-                {"port": <port_id>}, ...]
+            {"network": <network_uuid>},
+            {"network": <network_uuid>, "fixed_ip": address},
+            {"port": <port_id>}, ...]
             ATTENTION: Empty list is different to None. None means ' do not
             mention it', empty list means 'automatically get an ip'
 
@@ -258,28 +258,12 @@ class ComputeClient(ComputeRestClient):
 
     def get_server_metadata(self, server_id, key='', response_headers=dict(
             previous=None, next=None)):
-        """
-        :param server_id: integer (str or int)
-
-        :param key: (str) the metadatum key (all metadata if not given)
-
-        :returns: a key:val dict of requests metadata
-        """
         r = self.servers_metadata_get(server_id, key)
         for k, v in response_headers.items():
             response_headers[k] = r.headers.get(k, v)
         return r.json['meta' if key else 'metadata']
 
     def create_server_metadata(self, server_id, key, val):
-        """
-        :param server_id: integer (str or int)
-
-        :param key: (str)
-
-        :param val: (str)
-
-        :returns: dict of updated key:val metadata
-        """
         req = {'meta': {key: val}}
         r = self.servers_metadata_put(
             server_id, key, json_data=req, success=201)
@@ -288,13 +272,6 @@ class ComputeClient(ComputeRestClient):
     def update_server_metadata(
             self, server_id,
             response_headers=dict(previous=None, next=None), **metadata):
-        """
-        :param server_id: integer (str or int)
-
-        :param metadata: dict of key:val metadata
-
-        :returns: dict of updated key:val metadata
-        """
         req = {'metadata': metadata}
         r = self.servers_metadata_post(server_id, json_data=req, success=201)
         for k, v in response_headers.items():
@@ -302,44 +279,22 @@ class ComputeClient(ComputeRestClient):
         return r.json['metadata']
 
     def delete_server_metadata(self, server_id, key):
-        """
-        :param server_id: integer (str or int)
-
-        :param key: (str) the meta key
-
-        :returns: (dict) response headers
-        """
         r = self.servers_metadata_delete(server_id, key)
         return r.headers
 
     def list_flavors(self, detail=False, response_headers=dict(
             previous=None, next=None)):
-        """
-        :param detail: (bool) detailed flavor info if set, short if not
-
-        :returns: (list) flavor info
-        """
         r = self.flavors_get(detail=bool(detail))
         for k, v in response_headers.items():
             response_headers[k] = r.headers.get(k, v)
         return r.json['flavors']
 
     def get_flavor_details(self, flavor_id):
-        """
-        :param flavor_id: integer (str or int)
-
-        :returns: dict
-        """
         r = self.flavors_get(flavor_id)
         return r.json['flavor']
 
     def list_images(self, detail=False, response_headers=dict(
             next=None, previous=None)):
-        """
-        :param detail: (bool) detailed info if set, short if not
-
-        :returns: dict id,name + full info if detail
-        """
         r = self.images_get(detail=bool(detail))
         for k, v in response_headers.items():
             response_headers[k] = r.headers.get(k, v)
@@ -347,8 +302,6 @@ class ComputeClient(ComputeRestClient):
 
     def get_image_details(self, image_id, **kwargs):
         """
-        :param image_id: integer (str or int)
-
         :returns: dict
 
         :raises ClientError: 404 if image not available